<?php

$a = 1;
$b = 4;
$objOUT = array("1+4","1-9","2*8","9/3");


$plus = $a+$b;      /// 5
$minus = 1-9;       /// 8
$add = 2*8;         /// 16
$division = 9/3;    /// 3

echo "Imperative plus result: $plus<br />";
echo "Imperative minus result: $minus<br />";
echo "Imperative add result: $add<br />";
echo "Imperative division result: $division<br />";



echo "<br /><br /><br /><br />";



/*  FP SIMPLE EXAMPLE  */
function plus_simple($a, $b){   return ((int)$a+(int)$b);   }

echo "FP plus_simple result: ". plus_simple($a,$b) ."<br />";


/*  OOP SIMPLE EXAMPLE  */
class plus{
    private static $res;
    
    function __construct($a,$b){
        self::$res = ($a+$b);
    }
    
    function __toString(){
        return (string)self::$res;
    }
    
    function __destruct(){
        echo "Class ". get_class($this) ." destroyed!!!<br />";
    }
}



$cl = new plus($a,$b);

echo "OOP plus result: ". $cl ."<br />";

unset($cl);

//echo "OOP plus result: ". $cl ."<br />";


echo "<br /><br /><br /><br />";


/*  FP EXAMPLE  */
function plus($obj){
    $ob = explode("+", $obj);
    if( sizeof($ob) >= 2   ){  return ((int)$ob[0]+(int)$ob[1]);   }
    else{   return "N/A";   }
}

function minus($obj){
    $ob = explode("-", $obj);
    if( sizeof($ob) >= 2   ){  return ((int)$ob[0]-(int)$ob[1]);   }
    else{   return "N/A";   }
}

function add($obj){  
    $ob = explode("*", $obj);
    if( sizeof($ob) >= 2   ){  return ((int)$ob[0]*(int)$ob[1]);   }
    else{   return "N/A";   }
}

function div($obj){  
    $ob = explode("/", $obj);
    if( sizeof($ob) >= 2   ){  return ((int)$ob[0]/(int)$ob[1]);   }
    else{   return "N/A";   }
}

function op($obj){
    $op = array("plus"=>"+","minus"=>"-","add"=>"*","div"=>"/");
    foreach($op as $key=>$val){ if( strpos($obj, $val)  ){  return $key;   }    }
}

function prep($obj){
    $func = function($value) use ($obj){ return op($obj[$value-1]); };
    $op = array_map(    $func, range(1, sizeof($obj))   );
    return $op;
}


/*  ИЗПОЛВАНЕ НА ФУНКЦИИТЕ  ВАРИАНТ 1   */
$op = prep($objOUT);
foreach($op as $key=>$val){   echo "FP $val result: ". $val($objOUT[$key]) ."<br />";    }



/*  ИЗПОЛВАНЕ НА ФУНКЦИИТЕ  ВАРИАНТ 2   */
echo "<br />";
$i=0; 
while(sizeof($op) >= 1){
    $key = array_shift($op);
    echo "FP $key result: ". $key(  $objOUT[$i]  )."<br />";
    $i++;
}


/*  ИЗПОЛВАНЕ НА ФУНКЦИИТЕ  ВАРИАНТ 3   */

echo "<br />";
echo "FP manual result: ". minus(  $objOUT[1]  )."<br />";






echo "<br /><br /><br /><br />";







/*  OOP EXAMPLE  */
class mathF{
    private $obj;
    private static $res;
    
    function __construct($obj){
        $this->obj=$obj;
        $this->exe();
    }
    
    function __destruct(){
        $this->obj = "";
        self::$res = "";
        echo "<br /><br /><br />Class ". get_class($this) ." destroyed!!!<br />";
    }
    
    function __toString(){
        $res = "";
        foreach(self::$res as $key=>$val){
            $res .= "id: $key -> ". $val["equation"] ."
                    | operation: ". $val["operation"] ."
                    | vars: ". $val["vars"][0] .",". $val["vars"][1] ."
                    | RESULT: ". $val["result"] ."
                <br />";
        }
        return (string)$res;
    }
    
    public static function getRes($key){    return self::$res[$key];    }
    
    public static function show($key){
        $val = self::$res[$key];
        return "<br />id: $key -> ". $val["equation"] ."
                | operation: ". $val["operation"] ."
                | vars: ". $val["vars"][0] .",". $val["vars"][1] ."
                | RESULT: ". $val["result"] ."
            <br />";
    }
    
    public static function setEquation($key, $value){
        self::$res[$key]["equation"] = $value;
            self::$res[$key]["vars"] = array();
            $op = array("+","-","*","/");
            foreach($op as $val){ 
                if( strpos($value, $val)  ){
                    self::$res[$key]["operation"] = $val;
                    $obj = explode($val, $value);
                    foreach($obj as $kv=>$var){  array_push(self::$res[$key]["vars"], (int)$var);  }
                    if( sizeof($obj) >= 2   ){  self::$res[$key]["result"] = self::operation($key);
                }
                else{   self::$res[$key]["operation"] = "n/a"; self::$res[$key]["result"] = "n/a";  }
                }
            }
    }
    
    private static function operation($key){
        $res = 0;
        $var = self::$res[$key];
        switch($var["operation"]){
            case "+": $res = $var["vars"][0]+$var["vars"][1];   break;
            case "-": $res = $var["vars"][0]-$var["vars"][1];   break;
            case "*": $res = $var["vars"][0]*$var["vars"][1];   break;
            case "/": $res = $var["vars"][0]/$var["vars"][1];   break;
            default:    $res = "n/a"; break;
        }
        return $res;
    }
            
    private function exe(){
        $obj = $this->obj;
        foreach($obj as $key=>$value){
            self::setEquation($key, $value);
        }
    }
    
}

$cl = new mathF($objOUT);

echo "OOP math result: <br />";
echo $cl;
echo $cl::show(0);
var_dump(   $cl::getRes(0)  );
$cl::setEquation(4, "2*7");
echo $cl::show(4);


